/*
 * WARNING: this is an autogenerated file and will be overwritten by
 * the extension interface script.
 */

#include "s3eExt.h"
#include "IwDebug.h"
#include "s3eDevice.h"


#include "PokktNativeExtension.h"


// Define S3E_EXT_SKIP_LOADER_CALL_LOCK on the user-side to skip LoaderCallStart/LoaderCallDone()-entry.
// e.g. in s3eNUI this is used for generic user-side IwUI-based implementation.
#ifndef S3E_EXT_SKIP_LOADER_CALL_LOCK
#if defined I3D_ARCH_MIPS || (defined(WINAPI_FAMILY) && (WINAPI_FAMILY == WINAPI_FAMILY_PHONE_APP)) || defined I3D_ARCH_NACLX86_64
// For platforms missing stack-switching (MIPS, WP8, NaCl, etc.) make loader-entry via LoaderCallStart/LoaderCallDone() on the user-side.
#define LOADER_CALL_LOCK
#endif
#endif


#include "PokktNativeExtension_interface.h"

static PokktNativeExtensionFuncs g_Ext;
static bool g_GotExt = false;
static bool g_TriedExt = false;
static bool g_TriedNoMsgExt = false;

static bool _extLoad()
{
    if (!g_GotExt && !g_TriedExt)
    {
        s3eResult res = s3eExtGetHash(0x52d2b8b2, &g_Ext, sizeof(g_Ext));
        if (res == S3E_RESULT_SUCCESS)
            g_GotExt = true;
        else
            s3eDebugAssertShow(S3E_MESSAGE_CONTINUE_STOP_IGNORE,                 "error loading extension: PokktNativeExtension");

        g_TriedExt = true;
        g_TriedNoMsgExt = true;
    }

    return g_GotExt;
}

static bool _extLoadNoMsg()
{
    if (!g_GotExt && !g_TriedNoMsgExt)
    {
        s3eResult res = s3eExtGetHash(0x52d2b8b2, &g_Ext, sizeof(g_Ext));
        if (res == S3E_RESULT_SUCCESS)
            g_GotExt = true;
        g_TriedNoMsgExt = true;
        if (g_TriedExt)
            g_TriedExt = true;
    }

    return g_GotExt;
}

s3eBool PokktNativeExtensionAvailable()
{
    _extLoadNoMsg();
    return g_GotExt ? S3E_TRUE : S3E_FALSE;
}

s3eResult PokktNativeExtensionRegister(PokktNativeExtensionCallback cbid, s3eCallback fn, void* userData)
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[0] func: PokktNativeExtensionRegister"));

    if (!_extLoad())
        return S3E_RESULT_ERROR;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_PokktNativeExtensionRegister);
#endif

    s3eResult ret = g_Ext.m_PokktNativeExtensionRegister(cbid, fn, userData);

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_PokktNativeExtensionRegister);
#endif

    return ret;
}

s3eResult PokktNativeExtensionUnRegister(PokktNativeExtensionCallback cbid, s3eCallback fn)
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[1] func: PokktNativeExtensionUnRegister"));

    if (!_extLoad())
        return S3E_RESULT_ERROR;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_PokktNativeExtensionUnRegister);
#endif

    s3eResult ret = g_Ext.m_PokktNativeExtensionUnRegister(cbid, fn);

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_PokktNativeExtensionUnRegister);
#endif

    return ret;
}

void notifyExtensionOnNative(const char* operation, const char* param)
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[2] func: notifyExtensionOnNative"));

    if (!_extLoad())
        return;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_notifyExtensionOnNative);
#endif

    g_Ext.m_notifyExtensionOnNative(operation, param);

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_notifyExtensionOnNative);
#endif

    return;
}

bool isVideoAvailableOnNative()
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[3] func: isVideoAvailableOnNative"));

    if (!_extLoad())
        return false;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_isVideoAvailableOnNative);
#endif

    bool ret = g_Ext.m_isVideoAvailableOnNative();

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_isVideoAvailableOnNative);
#endif

    return ret;
}

double getVideoVcOnNative()
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[4] func: getVideoVcOnNative"));

    if (!_extLoad())
        return 0;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_getVideoVcOnNative);
#endif

    double ret = g_Ext.m_getVideoVcOnNative();

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_getVideoVcOnNative);
#endif

    return ret;
}

const char * getPokktSDKVersionOnNative()
{
    IwTrace(POKKTNATIVEEXTENSION_VERBOSE, ("calling PokktNativeExtension[5] func: getPokktSDKVersionOnNative"));

    if (!_extLoad())
        return NULL;

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallStart(S3E_TRUE, (void*)g_Ext.m_getPokktSDKVersionOnNative);
#endif

    const char * ret = g_Ext.m_getPokktSDKVersionOnNative();

#ifdef LOADER_CALL_LOCK
    s3eDeviceLoaderCallDone(S3E_TRUE, (void*)g_Ext.m_getPokktSDKVersionOnNative);
#endif

    return ret;
}
