/*
java implementation of the PokktNativeExtension extension.

Add android-specific functionality here.

These functions are called via JNI from native code.
*/
/*
 * NOTE: This file was originally written by the extension builder, but will not
 * be overwritten (unless --force is specified) and is intended to be modified.
 */
import com.ideaworks3d.marmalade.LoaderAPI;
// Comment in the following line if you want to use ResourceUtility
// import com.ideaworks3d.marmalade.ResourceUtility;

import com.app.pokktsdk.util.Logger;

class PokktNativeExtension
{
    public static native void NotifyCPP(String operation, String params);

    public void notifyExtensionOnNative(String operation, String param)
    {
    	Logger.d("[POKKT-JAVA] operation: " + operation + ", param: " + param);

        switch (operation) 
        {

            // Common Methods
            case "setParams":
                PokktManagerHandler.setParams(param);
                break;
            case "setDebug":
                PokktManagerHandler.setDebug(param.equals("true"));
                break;
            case "showLog":
                PokktManagerHandler.showLog(param);
                break;
            case "showToast":
                PokktManagerHandler.showToast(param);
                break;
            case "setThirdPartyUserId":
                PokktManagerHandler.setThirdPartyUserId(param);
                break;

            // Session Methods
            case "startSession":
                PokktManagerHandler.startSession();
                break;
            case "endSession":
                PokktManagerHandler.endSession();
                break;

            // Offerwall Methods
            case "setCloseOnSuccessFlag":
                PokktManagerHandler.setCloseOnSuccessFlag(Boolean.valueOf(param));
                break;
            case "getCoins":
                PokktManagerHandler.getCoins(param);
                break;
            case "getPendingCoins":
                PokktManagerHandler.getPendingCoins();
                break;
            case "checkOfferWallCampaign":
                PokktManagerHandler.checkOfferWallCampaign();
                break;

            // Video Methods
            case "getVideo":
                PokktManagerHandler.getVideo(param);
                break;
            case "getVideoNonIncent":
                PokktManagerHandler.getVideoNonIncent(param);
                break;
            case "cacheVideoCampaign":
                PokktManagerHandler.cacheVideoCampaign();
                break;
            case "setSkipEnabled":
                PokktManagerHandler.setSkipEnabled(Boolean.valueOf(param));
                break;
            case "setDefaultSkipTime":
                PokktManagerHandler.setDefaultSkipTime(Integer.valueOf(param));
                break;
            case "setCustomSkipMessage":
                PokktManagerHandler.setCustomSkipMessage(param);
                break;
            case "setBackButtonDisabled":
                PokktManagerHandler.setBackButtonDisabled(Boolean.valueOf(param));
                break;

            // Optional Methods
            case "setName":
                PokktManagerHandler.setName(param);
                break;
            case "setAge":
                PokktManagerHandler.setAge(param);
                break;
            case "setSex":
                PokktManagerHandler.setSex(param);
                break;
            case "setMobileNo":
                PokktManagerHandler.setMobileNo(param);
                break;
            case "setEmailAddress":
                PokktManagerHandler.setEmailAddress(param);
                break;
            case "setLocation":
                PokktManagerHandler.setLocation(param);
                break;
            case "setBirthday":
                PokktManagerHandler.setBirthday(param);
                break;
            case "setMaritalStatus":
                PokktManagerHandler.setMaritalStatus(param);
                break;
            case "setFacebookId":
                PokktManagerHandler.setFacebookId(param);
                break;
            case "setTwitterHandle":
                PokktManagerHandler.setTwitterHandle(param);
                break;
            case "setEducation":
                PokktManagerHandler.setEducation(param);
                break;
            case "setNationality":
                PokktManagerHandler.setNationality(param);
                break;
            case "setEmployment":
                PokktManagerHandler.setEmployment(param);
                break;
            case "setMaturityRating":
                PokktManagerHandler.setMaturityRating(param);
                break;
                
            case "setGoogleAnalyticsID":
                PokktManagerHandler.setGoogleAnalyticsID(param);
                break;
            case "setMixPanelProjectToken":
                PokktManagerHandler.setMixPanelProjectToken(param);
                break;
            case "setFlurryApplicationKey":
                PokktManagerHandler.setFlurryApplicationKey(param);
                break;
            case "setSelectedAnalyticsType":
                PokktManagerHandler.setSelectedAnalyticsType(param);
                break;
            case "sendAppInfo":
                PokktManagerHandler.sendAppInfo();
                break;
            case "exportLog":
                PokktManagerHandler.exportLog();
                break;
            default:
                Logger.d("Unknown operation requested : " + operation + ", with param: " + param);
                break;
        }
    }
    
    public boolean isVideoAvailableOnNative()
    {
        return PokktManagerHandler.isVideoAvailablePokkt();
    }
    
    public double getVideoVcOnNative()
    {
        return PokktManagerHandler.getVideoVc();
    }
	
	public String getPokktSDKVersionOnNative()
    {
		Logger.d("[POKKT-JAVA] getPokktSDKVersionOnNative");
		Logger.d("[POKKT-JAVA] getPokktSDKVersionOnNative::::" + PokktManagerHandler.getSDKVersion());
        return PokktManagerHandler.getSDKVersion();
    }
}
