/*
 * Internal header for the PokktNativeExtension extension.
 *
 * This file should be used for any common function definitions etc that need to
 * be shared between the platform-dependent and platform-indepdendent parts of
 * this extension.
 */

/*
 * NOTE: This file was originally written by the extension builder, but will not
 * be overwritten (unless --force is specified) and is intended to be modified.
 */


#ifndef POKKTNATIVEEXTENSION_INTERNAL_H
#define POKKTNATIVEEXTENSION_INTERNAL_H

#include "s3eTypes.h"
#include "PokktNativeExtension.h"
#include "PokktNativeExtension_autodefs.h"


/**
 * Initialise the extension.  This is called once then the extension is first
 * accessed by s3eregister.  If this function returns S3E_RESULT_ERROR the
 * extension will be reported as not-existing on the device.
 */
s3eResult PokktNativeExtensionInit();

/**
 * Platform-specific initialisation, implemented on each platform
 */
s3eResult PokktNativeExtensionInit_platform();

/**
 * Terminate the extension.  This is called once on shutdown, but only if the
 * extension was loader and Init() was successful.
 */
void PokktNativeExtensionTerminate();

/**
 * Platform-specific termination, implemented on each platform
 */
void PokktNativeExtensionTerminate_platform();
void notifyExtensionOnNative_platform(const char* operation, const char* param);

bool isVideoAvailableOnNative_platform();

double getVideoVcOnNative_platform();

const char * getPokktSDKVersionOnNative_platform();

void scheduleNotification_platform();


#endif /* !POKKTNATIVEEXTENSION_INTERNAL_H */