//
//  OfferwallScreen.h
//  PokktSample
//
//  Created by Pankaj Kumar on 22/04/15.
//
//

#ifndef __PokktSample__OfferwallScreen__
#define __PokktSample__OfferwallScreen__

#include "scene.h"
#include <string>
#include "PokktMarmaladeConfig.h"
#include "PokktDelegate.h"

class OfferwallScreen : public Scene, public PokktDelegate
{
private:
    CSprite* getOfferwallBtn;
    CSprite* getOfferwallWithFixedValueBtn;
    CSprite* incompleteCallBtn;
    
    CLabel* pointsEarnedLbl;
    
    // pokkt handlers
    void handleCoinResponse(std::string coins);
    void handleCoinResponseWithTrId(std::string coinsWithTrId);
    void handleCoinResponseFailed(std::string message);
    void handleCampaignAvailibity(std::string message);
    void handleOfferwallclosed(std::string message);
    
    int _coinsEarned = 0;
    
    static PokktMarmaladeConfig *pokktConfig;
    
public:
    OfferwallScreen();
    ~OfferwallScreen();
    
    void Init();
    void Update(float deltaTime = 0.0f, float alphaMul = 1.0f);
    void Render();
    void initPokkt();
};

#endif /* defined(__PokktSample__OfferwallScreen__) */
